<script lang="ts">
	import { onMount } from 'svelte';
	import axios from 'axios';
	import Backdrop from '../lib/Backdrop.svelte';

	type Event = {
		title: string;
		img?: string;
		venue: string;
		datetime?: string;
		url?: string;
	};

	let events: Event[];
	let selectedEvent: Event | undefined = undefined;
	// let isEventSelected = false;

	const onEventClick = (event: Event) => {
		selectedEvent = event;
	};

	onMount(async () => {
		const res = await axios.get('/api/events');
		events = res.data;
	});
</script>

<svelte:head>
	<title>Home</title>
	<meta name="description" content="Svelte demo app" />
</svelte:head>

{#if selectedEvent}
	<Backdrop on:click={() => (selectedEvent = undefined)} />
	<div
		class="CenteredModal flex flex-col fixed top-1/2 left-1/2 shadow-md p-3 rounded-lg z-50 bg-white overflow-y-auto"
	>
		<div class="ml-auto">X</div>
		<div class="flex flex-col items-start gap-2 p-4">
			<img src={selectedEvent.img} alt={selectedEvent.title} />
			<div class="text-2xl font-bold">{selectedEvent.title}</div>
			<div class="text-gray-500">{selectedEvent.datetime}</div>
			<div class="rounded-lg text-green-900 bg-green-100 px-2 py-0.5 text-xs">
				{selectedEvent.venue}
			</div>
			<a
				class="bg-gray-600 p-4 font-lg font-bold"
				href={selectedEvent.url}
				target="_blank
      ">Külasta sündmust</a
			>
		</div>
	</div>
{/if}

{#if events}
	<div class="p-5 sm:p-8">
		<div
			class="columns-1 gap-5 sm:columns-2 sm:gap-8 md:columns-3 lg:columns-6 [&>div:not(:first-child)]:mt-8"
		>
			{#each events as event}
				<div
					class="rounded-lg shadow-md overflow-hidden cursor-pointer"
					on:click={() => onEventClick(event)}
				>
					<img src={event.img} alt={event.title} />
					<div class="flex flex-col items-start gap-2 p-4">
						<div class="text-2xl font-bold">{event.title}</div>
						<div class="text-gray-500">{event.datetime}</div>
						<div class="rounded-lg text-green-900 bg-green-100 px-2 py-0.5 text-xs">
							{event.venue}
						</div>
					</div>
				</div>
			{/each}
		</div>
	</div>
{/if}

<style>
	.CenteredModal {
		width: 95%;
		max-width: 700px;
		max-height: 95%;
		min-height: 70%;
		transform: translate(-50%, -50%);
		z-index: 1000;
	}
	@media (max-width: 767.98px) {
		.CenteredModal {
			max-width: 90%;
			padding: var(--spacing-24);
		}
	}

	@media (max-width: 575.98px) {
		.CenteredModal {
			max-width: 100%;
			padding: var(--spacing-8);
		}
	}
</style>
